package cn.iocoder.yudao.module.system.service.biz;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.api.bpm.vo.CateringChangeRecordRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.DeviceProductDO;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.DeviceWarnDO;
import cn.iocoder.yudao.module.system.dal.mysql.biz.DeviceProductMapper;
import cn.iocoder.yudao.module.system.dal.mysql.biz.DeviceWarnMapper;
import cn.iocoder.yudao.module.system.dal.mysql.biz.ElderlyInfoMapper;
import cn.iocoder.yudao.module.system.dal.mysql.tenant.TenantMapper;
import cn.iocoder.yudao.module.system.enums.change.BusinessTypeEnum;
import cn.iocoder.yudao.module.system.enums.change.ChangeTypeEnum;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.DEVICE_PRODUCT_NOT_EXISTS;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.DEVICE_WARN_NOT_EXISTS;

/**
 * @Author: jinyd
 * @CreateTime: 2024/10/28  10:50
 * @Description:
 * @Version: 4.0
 */

@Service
@Validated
public class DeviceWarnServiceImpl implements DeviceWarnService {

    @Resource
    private DeviceWarnMapper warnMapper;

    @Resource
    private BuildService buildService;

    @Override
    public Long createWarn(DeviceWarnSaveReqVO createReqVO) {
        // 插入
        DeviceWarnDO warn = BeanUtils.toBean(createReqVO, DeviceWarnDO.class);
        warnMapper.insert(warn);
        // 返回
        return warn.getId();
    }

    @Override
    public void updateWarn(DeviceWarnSaveReqVO updateReqVO) {
        // 校验存在
        validateWarnExists(updateReqVO.getId());
        // 更新
        DeviceWarnDO updateObj = BeanUtils.toBean(updateReqVO, DeviceWarnDO.class);
        warnMapper.updateById(updateObj);
    }

    @Override
    public void deleteWarn(Long id) {
        // 校验存在
        validateWarnExists(id);
        // 删除
        warnMapper.deleteById(id);
    }

    private void validateWarnExists(Long id) {
        if (warnMapper.selectById(id) == null) {
            throw exception(DEVICE_WARN_NOT_EXISTS);
        }
    }

    @Override
    public DeviceWarnDO getWarn(Long id) {
        return warnMapper.selectById(id);
    }

    @Override
    public PageResult<DeviceWarnRespVO> getWarnPage(DeviceWarnPageReqVO pageReqVO) {
        Page<DeviceWarnRespVO> page = new Page<>(pageReqVO.getPageNo(), pageReqVO.getPageSize());
        List<DeviceWarnRespVO> list = warnMapper.selectPageList(page, pageReqVO);
        DeviceWarnPageDdetailVO deviceWarnPageDdetailVO = warnMapper.getDetail(pageReqVO.getDeviceProductId());
        if (null != deviceWarnPageDdetailVO && null != deviceWarnPageDdetailVO.getBindingUserId()) {
            deviceWarnPageDdetailVO.setBedName(buildService.getFullBedName(deviceWarnPageDdetailVO.getBindingUserId()));
        }
        return new PageResult<>(list, page.getTotal(), deviceWarnPageDdetailVO);
    }
}
